function  [ Hpose]=PlotHand3DPose(Hand3DPose,Hpose1,flag2D3D,lineWidth,markerSize, col, col1, col2, col3, col4, col5, Hpose)

if nargin<2
    Hpose=zeros(27,1);
else
    Hpose=Hpose1;
end
if nargin<6
    col='cyan';    col2='magenta';     col1='green';
    col5='red';   col4='yellow';    col3='cyan';
end
if nargin<3
    flag2D3D=1;
end
if nargin<4
    lineWidth=4;
end
if nargin<5
    markerSize=15;
end
lengthvec=length(Hand3DPose);
NumJoints=lengthvec/3;
zs = Hand3DPose(NumJoints*2+1:NumJoints*3,1);
xs = Hand3DPose(1:NumJoints,1);
ys = Hand3DPose(NumJoints+1:NumJoints*2,1);

%%%%%% Build the list of segment and associate color
ind=0;

if xs(3)~=xs(4)
    ind=ind+1;%%% Collar -  Shoulder
    vec=[3 4];
    [Segm(ind,:),DistZ(ind),colorSegm{ind}]=AddSegment(xs(vec),ys(vec),zs(vec), col);
    
    ind=ind+1;%%% Shoulder - Elbow
    vec=[4 5];
    [Segm(ind,:),DistZ(ind),colorSegm{ind}]=AddSegment(xs(vec),ys(vec),zs(vec), col);
    
end

ind=ind+1;%%% Elbow - Wrist
vec=[5 26];
[Segm(ind,:),DistZ(ind),colorSegm{ind}]=AddSegment(xs(vec),ys(vec),zs(vec), col);
%%% 5 fingers
for f=1:5
    eval(['colfinger= col' num2str(f) ';']);
    if f==5
        ind=ind+1;
        vec=[5+(f-1)*4+1 26];
        [Segm(ind,:),DistZ(ind),colorSegm{ind}]=AddSegment(xs(vec),ys(vec),zs(vec), colfinger);
    elseif f<4
        ind=ind+1;
        vec=[5+(f-1)*4+1 26];
        [Segm(ind,:),DistZ(ind),colorSegm{ind}]=AddSegment(xs(vec),ys(vec),zs(vec), colfinger);
        ind=ind+1;
        vec=[5+(f-1)*4+1 5+(f)*4+1];
        [Segm(ind,:),DistZ(ind),colorSegm{ind}]=AddSegment(xs(vec),ys(vec),zs(vec), colfinger);
    elseif f==4
        ind=ind+1;
        vec=[5+(f-1)*4+1 26];
        [Segm(ind,:),DistZ(ind),colorSegm{ind}]=AddSegment(xs(vec),ys(vec),zs(vec), colfinger);
        ind=ind+1;
        vec=[5+(f-1)*4+1 5+(f)*4+1+1];
        [Segm(ind,:),DistZ(ind),colorSegm{ind}]=AddSegment(xs(vec),ys(vec),zs(vec), colfinger);
    end
    ind=ind+1;
    vec=[5+(f-1)*4+1 5+(f-1)*4+2];
    [Segm(ind,:),DistZ(ind),colorSegm{ind}]=AddSegment(xs(vec),ys(vec),zs(vec), colfinger);
    
    ind=ind+1;
    vec=[5+(f-1)*4+2 5+(f-1)*4+3];
    [Segm(ind,:),DistZ(ind),colorSegm{ind}]=AddSegment(xs(vec),ys(vec),zs(vec), colfinger);
    
    ind=ind+1;
    vec=[5+(f-1)*4+3  5+(f-1)*4+4];
    [Segm(ind,:),DistZ(ind),colorSegm{ind}]=AddSegment(xs(vec),ys(vec),zs(vec), colfinger);
end

[~,vecSegm]=sort(DistZ,'descend');


if flag2D3D==1
    for s=vecSegm
        if DistZ(s)>0.00001
            % if isempty(Hpose)==1
            if isempty(Hpose)==1|| Hpose(s,:)==0
                if sum(Segm(s,5:6)>0)==2
                    Hpose(s,:)=plot(Segm(s,1:2),Segm(s,3:4),'-k.','color','black', 'LineWidth',lineWidth+1,'MarkerSize',markerSize+2);hold on
                   Hpose(s+length(vecSegm),:)=plot(Segm(s,1:2),Segm(s,3:4), '-k.','color',colorSegm{s}, 'LineWidth',lineWidth-2,'MarkerSize',markerSize-2);
                end
            else
                if sum(Segm(s,5:6)>0)==2
                    set(Hpose(s,:),'XData',Segm(s,1:2),'YData', Segm(s,3:4))
                    set(Hpose(s+length(vecSegm),:),'XData',Segm(s,1:2),'YData', Segm(s,3:4))
                end
            end
        end
    end
else
    
    if isempty(Hpose)==1
        for s=vecSegm
            Hpose(s,:)=plot3(Segm(s,1:2),Segm(s,3:4),Segm(s,5:6),'-k.','color','black', 'LineWidth',lineWidth+1,'MarkerSize',markerSize+2);hold on
            Hpose(s+length(vecSegm),:)=plot3(Segm(s,1:2),Segm(s,3:4),Segm(s,5:6), '-k.','color',colorSegm{s}, 'LineWidth',lineWidth-2,'MarkerSize',markerSize-2);
        end
    else
        for s=vecSegm
            set(Hpose(s,:),'XData',Segm(s,1:2),'YData', Segm(s,3:4));
            set(Hpose(s+length(vecSegm),:),'XData',Segm(s,1:2),'YData', Segm(s,3:4));
        end
    end
end
hold off

function [Segm,DistZ,col]=AddSegment(xs,ys,zs, col)
Segm =[xs ; ys ;  zs ];
if prod(sign(zs))==-1
    DistZ =max(zs) ;
else
    DistZ =min(zs) ;
end