function visualize_UCI_EGO()

% data info
dataDir='Seq%d/fr%d%s';
endFr(1)=961;
endFr(2)=685;
endFr(3)=1000;
endFr(4)=1000;


for seq=1:4
    for ii= 1:10:endFr(seq)
        fprintf('Video no %4g - Frame no......%4g\n',seq, ii)
        
        %load and visualize RGB-D images
        I=imread(sprintf(dataDir, seq ,ii, '.jpg'));
        D=imread(sprintf(dataDir, seq ,ii, '_z.png'));
        
        figure(1), subplot(1,2,1), imagesc(I); 
        figure(1), subplot(1,2,2), imagesc(D,[100 1500]); colormap(gray); 
        % load and visualize the first hand (if any visible)
        if exist(sprintf(dataDir, seq ,ii, '-1_z.txt'),'file')
            
            Hand2D=parseHandFile(sprintf(dataDir, seq ,ii, '-1.txt'));
            figure(1), subplot(1,2,1),hold on, PlotHand3DPose(Hand2D);hold off
            axis([0 640 0 480]), axis equal
            
            Hand2D_z=parseHandFile(sprintf(dataDir, seq ,ii, '-1_z.txt'));
            figure(1), subplot(1,2,2),hold on,PlotHand3DPose(Hand2D_z);hold off
            axis([0 320 0 240]), axis equal
        end
        
        % load and visualize the second hand (if visible)
        if exist(sprintf(dataDir, seq ,ii, '-2_z.txt'),'file')
            
            Hand2D=parseHandFile(sprintf(dataDir, seq ,ii, '-2.txt'));
            figure(1), subplot(1,2,1),hold on,PlotHand3DPose(Hand2D);hold off
            axis([0 640 0 480]), axis equal
            
            Hand2D_z=parseHandFile(sprintf(dataDir, seq ,ii, '-2_z.txt'));
            figure(1), subplot(1,2,2),hold on,PlotHand3DPose(Hand2D_z);hold off
            axis([0 320 0 240]), axis equal
            
        end
        pause(0.1)
    end
end

end
function Hand2D=parseHandFile(txtFile)
Hand2D=zeros(26*3,1);
fid=fopen(txtFile);

for i=1:26
    %% $JointX $JointY $JointZ
    tline=fgets(fid);
    t=strfind(tline,':');
    Hand2D([i i+26 i+52] ,1)=str2num(tline(t+1:end));
end
fclose(fid);

end
